// ss.cpp : Combine & reformat application.
//
//  Updates:   
//
//   1) Expanded Output of feeder to 4 digits   ??/??/2004
//   2) Added board_num parm                    08/03/2005
//

#include "stdafx.h"
#include <iostream>
#include <cstring>
#include <fstream>
#include <iomanip>
#include <time.h>    // ctime?
#include <sys/timeb.h>

#include <time.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/timeb.h>
#include <string.h>

using std::cin;
using std::cout;
using std::cerr;
using std::endl;
using std::ios;
using std::ifstream;
using std::ofstream;

char h_file[64];
char l_file[64];
char r_file[64];
char o_file[64];
char board_num[2];                                        // 08/03/2005
char board_tmp[2];                                        // 08/03/2005

const char spaces[] = "                                                            ";
const int LINESIZE = 256;
char line[LINESIZE];
char* token;

//---------------------------------------------------------------------
// Date & time data
//---------------------------------------------------------------------

char os_date[12];
char os_time[12];
char datetime[24];

//---------------------------------------------------------------------
// Data from h_file
//---------------------------------------------------------------------

char mach_name[32];
char pgm_name[32];

//---------------------------------------------------------------------
// Data from l_file
//---------------------------------------------------------------------

int lctr = 0;
int lsub;

char location[1000][12];
int  size[1000];
char partnum[1000][32];
int  count[1000];
char comment[1000][32];

int  totalcount;

//---------------------------------------------------------------------
// Data from r_file
//---------------------------------------------------------------------

int rctr = 0;
int rsub;

char rlocation[10000][12];
char rref[10000][6];

//---------------------------------------------------------------------
// Function definitions
//---------------------------------------------------------------------

void display_usage(char *);
void rfmt(char *);
int str2int(char *);
int istrlen(char *);
void rjust_count(int count);

//---------------------------------------------------------------------
// This is the main body of the program.
//---------------------------------------------------------------------

int main(int argc, char* argv[])
{
	if (argc == 1)  // Check for zero arguments
	{
		cerr << "No arguments specified." << endl;
		display_usage(argv[0]);
		return 0;
	}
	

	//---------------------------------------------------------------------
	// Process the command-line args.
	//---------------------------------------------------------------------

	bool argerrs = false;
//	const char *f_pfx[5] = {"/?", "/h", "/l", "/r", "/o"};        8/3/2005
	const char *f_pfx[6] = {"/?", "/h", "/l", "/r", "/o", "/b"};
	int i = 1;

	while (i < argc)
	{
		if (strcmp(argv[i],f_pfx[0]) == 0)			// Process /?
		{
			display_usage(argv[0]);
			return 0;
		}
		else if (strcmp(argv[i],f_pfx[1]) == 0)		// Process /h
		{
			if (argc > i + 1)
			{
				strcpy(h_file, argv[i + 1]);
				i += 2;
			}
			else
			{
				cerr << "Missing value for: " << argv[i] << endl;
				++i;
				argerrs = true;

			}
		}
		else if (strcmp(argv[i],f_pfx[2]) == 0)		// Process /l
		{
			if (argc > i + 1)
			{
				strcpy(l_file, argv[i + 1]);
				i += 2;
			}
			else
			{
				cerr << "Missing value for: " << argv[i] << endl;
				++i;
				argerrs = true;

			}
		}
		else if (strcmp(argv[i],f_pfx[3]) == 0)		// Process /r
		{
			if (argc > i + 1)
			{
				strcpy(r_file, argv[i + 1]);
				i += 2;
			}
			else
			{
				cerr << "Missing value for: " << argv[i] << endl;
				++i;
				argerrs = true;

			}
		}
		else if (strcmp(argv[i],f_pfx[4]) == 0)		// Process /o
		{
			if (argc > i + 1)
			{
				strcpy(o_file, argv[i + 1]);
				i += 2;
			}
			else
			{
				cerr << "Missing value for: " << argv[i] << endl;
				++i;
				argerrs = true;

			}
		}
		else if (strcmp(argv[i],f_pfx[5]) == 0)		// Process /b  08/03/2005
		{
			if (argc > i + 1)
			{
				strcpy(board_num, argv[i + 1]);
				i += 2;
			}
			else
			{
				cerr << "Missing value for: " << argv[i] << endl;
				++i;
				argerrs = true;

			}
		}
		else
		{
			cerr << "Unrecognized arg: " << argv[i] << endl;
			++i;
			argerrs = true;
		}

	} 

	if (argerrs)
		return -1;

	//---------------------------------------------------------------------
	// Get OS date & time
	//---------------------------------------------------------------------

    _tzset();      // Set time zone from TZ environment variable.

    _strdate(os_date);
    _strtime(os_time);

	char *dt = &datetime[0];
	char c3[4];
	int  i3;
	int  ihour;

	// Day of month

	c3[0] = os_date[3];
	c3[1] = os_date[4];
	c3[2] = '\0';
	i3 = str2int(c3);

//	cout << "Day str = " << c3 << endl;
//	cout << "Day Int = " << i3 << endl;

	if (i3 < 10)
	{
		c3[0] = c3[1];
		c3[1] = '\0';
	}
	strcpy(datetime, c3);
	
	// Monthname

	const char *month[12] = {" Jan", " Feb", " Mar", " Apr", " May", " Jun",
							 " Jul", " Aug", " Sep", " Oct", " Nov", " Dec"};

	c3[0] = os_date[0];
	c3[1] = os_date[1];
	i3 = str2int(c3);

	strcat(datetime, month[i3 - 1]);
	
	// Year

	strcat(datetime, " 20");
	
	c3[0] = os_date[6];
	c3[1] = os_date[7];

	strcat(datetime, c3);
	
	// Hour

	const char *hour[24] = {" 12", " 1", " 2", " 3", " 4",  " 5",
							" 6",  " 7", " 8", " 9", " 10", " 11",
							" 12", " 1", " 2", " 3", " 4",  " 5",
							" 6",  " 7", " 8", " 9", " 10", " 11"};

	c3[0] = os_time[0];
	c3[1] = os_time[1];
	ihour = str2int(c3);

	strcat(datetime, hour[ihour]);
	
	// Minute

	strcat(datetime, ":");
	
	c3[0] = os_time[3];
	c3[1] = os_time[4];

	strcat(datetime, c3);

	// AM/PM

	if (ihour < 12)
		strcat(datetime, " AM");
	else
		strcat(datetime, " PM");

	//---------------------------------------------------------------------
	// Open & process "header" file, h_file.
	//---------------------------------------------------------------------

	ifstream hf;
	hf.open(h_file, ios::in);

	if (hf.fail()) // Unable to open file
	{
		cerr << "Error opening headerfile: " << h_file << endl;
		return -1;
	}

	hf.getline(line, LINESIZE, '\n');
	while (!hf.fail())
	{
		token = strtok(&line[0], ",");

		int tempint = strncmp(token, "Machine Name", 12);

        if (strncmp(token, "Machine Name", 12) == 0)
		{
			token = strtok(NULL, ",");
			strcpy(mach_name,token);
		}
		else if (strncmp(token,"Recipe Name", 11) == 0)
		{
			token = strtok(NULL, ",");
			strcpy(pgm_name,token);
		}

		hf.getline(line, LINESIZE, '\n');
	}

	hf.close();

	if (strcmp(o_file,"") == 0)
	{
		strcpy(o_file,mach_name);
		strcat(o_file,".stp");
	}

	//---------------------------------------------------------------------
	// Open & process "location" file, l_file.
	//---------------------------------------------------------------------

	char *x, *y;
	int l;

	ifstream lf;
	lf.open(l_file, ios::in);

	if (lf.fail()) // Unable to open file
	{
		cerr << "Error opening locfile: " << l_file << endl;
		return -1;
	}

	lf.getline(line, LINESIZE, '\n');        // Discard first line (column headers)
	lf.getline(line, LINESIZE, '\n');
	while (!lf.fail())
	{
		token = strtok(&line[0], ",");       // First token is location

		rfmt(token);

		strcpy(&location[lctr][0], token);

		token = strtok(NULL, ",");       // Second token is part number

//		cout << "token  2 <<" << token << ">>" << endl;
		
		strcpy(&partnum[lctr][0], token);
		
		token = strtok(NULL, ",");       // Third & fourth tokens are discarded
		token = strtok(NULL, ",");

		token = strtok(NULL, ",");       // Fifth token is size

//		cout << "token  5 <<" << token << ">>" << endl;

		// reformat token to derive integer value

		x = token;
		y = token;
		l = 0;

		while(*x != '\0')
		{
			if ((*x >= '0') && (*x <= '9'))
			{
				if (x != y)
				{
					*y = *x;
				}
				++l;
				++y;
			}
			++x;
		}
		*y = '\0';

		size[lctr] = str2int(token);

		token = strtok(NULL, ",");       // Sixth through eleventh tokens are discarded
		token = strtok(NULL, ",");
		token = strtok(NULL, ",");
		token = strtok(NULL, ",");
		token = strtok(NULL, ",");
		token = strtok(NULL, ",");

		token = strtok(NULL, ",");       // Twelfth token is comment

		if (token != NULL)
		{
//			cout << "token 12 <<" << token << ">>" << endl;
			strcpy(&comment[lctr][0], token);
		}

		++lctr;		
		lf.getline(line, LINESIZE, '\n');
	}

	lf.close();

	//---------------------------------------------------------------------
	// Open & process "reference" file, r_file.
	//---------------------------------------------------------------------

	ifstream rf;
	rf.open(r_file, ios::in);

	if (rf.fail()) // Unable to open file
	{
		cerr << "Error opening reffile: " << r_file << endl;
		return -1;
	}

	rf.getline(line, LINESIZE, '\n');        // Discard first line (column headers)
	rf.getline(line, LINESIZE, '\n');
	while (!rf.fail())
	{

		token = strtok(&line[0], ",");   // First token is discarded

		token = strtok(NULL, ",");       // Second token is board number 08/03/2005
		if (istrlen(board_num) != 0)
		{
			strcpy(board_tmp,token);
		}

		token = strtok(NULL, ",");       // Third token is reference

		strcpy(&rref[rctr][0], token);

		token = strtok(NULL, ",");       // Fourth token is discarded

		token = strtok(NULL, ",");       // Fifth token is location

		rfmt(token);

		strcpy(&rlocation[rctr][0], token);

        // If /b parameter is specified, keep only lines with matching board_number 08/03/2005
		
		if (strcmp(board_num, board_tmp) == 0)
		{

			// Increment reference count for location & totalcount.

			lsub = lctr;
			while ((lsub >= 0))
			{
				if (strcmp(&rlocation[rctr][0], &location[lsub][0]) == 0)
				{
					++count[lsub];
					lsub = 0;
				}
				--lsub;
			}

			++totalcount;

			++rctr;		
		}

		rf.getline(line, LINESIZE, '\n');
	}

	rf.close();

//	cout << "os_date....: " << os_date    << endl;
//	cout << "os_time....: " << os_time    << endl;
//	cout << "datetime...: " << datetime   << endl;
//	cout << "h_file.....: " << h_file     << endl;
//	cout << "l_file.....: " << l_file     << endl;
//	cout << "r_file.....: " << r_file     << endl;
//	cout << "o_file.....: " << o_file     << endl;
//	cout << "board_num..: " << board_num  << endl;
//	cout << "mach_name..: " << mach_name  << endl;
//	cout << "pgm_name...: " << pgm_name   << endl;

//	char *z;
//	lsub = 0;
//	while (lsub < lctr)
//	{
//		x = &location[lsub][0];
//		y = &partnum[lsub][0];
//		z = &comment[lsub][0];
//		cout << "l-data["  << lsub
//			 << "]: "      << x 
//			 << " <> "     << y
//			 << " <> "     << size[lsub]
//			 << " <> "     << z 
//			 << " <> "     << count[lsub] << endl;
//		++lsub;
//	}
//
//	rsub = 0;
//	while (rsub < rctr)
//	{
//		x = &rlocation[rsub][0];
//		y = &rref[rsub][0];
//		cout << "r-data["  << rsub
//			 << "]: "      << x 
//			 << " <> "     << y << endl;
//		++rsub;
//	}
//	cout << "totalcount.: " << totalcount   << endl;

	//---------------------------------------------------------------------
	// Open & generate output file, o_file.
	//---------------------------------------------------------------------

	ofstream of;
	of.open(o_file, ios::out);

	if (of.fail()) // Unable to open file
	{
		cerr << "Error opening outfile: " << o_file << endl;
		return -1;
	}

	int olen;  // Output line length.

	strcpy(line, "Machine Name: ");		// Header line 1 & 2
	strcat(line, mach_name);
	strcat(line, "\n\n");
	olen = istrlen(line);
	of.write(line, olen);

	strcpy(line, "Program Name: ");		// Header line 3 & 4
	strcat(line, pgm_name);
	strcat(line, "\n\n");
	olen = istrlen(line);
	of.write(line, olen);

	strcpy(line, "Date:         ");		// Header line 5, 6 & 7
	strcat(line, datetime);
	strcat(line, "\n\n\n");
	olen = istrlen(line);
	of.write(line, olen);

	// Header line 8 & 9

	strcpy(line, "Feeder   Type      *   Part Number      *   Count   ");
	strcat(line, "Reference              *   Description              *\n");
	strcat(line, "----------------------------------------------------");
	strcat(line, "-----------------------------------------------------\n");
	olen = istrlen(line);
	of.write(line, olen);


	for (lsub = 0; lsub < lctr; lsub++)
	{
		strcpy(line,location[lsub]);						// Location
		strncat(line,spaces, (9 - istrlen(line)));

		switch (size[lsub])									// Size
		{
			case  8: strcat(line, "8x4           "); break;
			case 12: strcat(line, "12x8          "); break;
			case 16: strcat(line, "16x8          "); break;
			case 24: strcat(line, "24x12         "); break;
			case 32: strcat(line, "32x24         "); break;
			case 44: strcat(line, "44x32         "); break;
			case 56: strcat(line, "56x44         "); break;
			default: strcat(line, "?????         "); break;
		}

		strcat(line,partnum[lsub]);							// Part number
		strncat(line,spaces, (79 - istrlen(line)));

		strcat(line,comment[lsub]);							// Description (comment)

		rjust_count(count[lsub]);

		i = 52;

		int j;

		rsub = 0;
		while (rsub < rctr)
		{
			if (strcmp(location[lsub], rlocation[rsub]) == 0)
			{
				if (i + istrlen(rref[rsub]) > 77)
				{
					strcat(line, "\n");
					olen = istrlen(line);
					of.write(line, olen);
					strcpy(line,spaces);
					strncat(line,spaces,20);
					i = 52;
				}
				
				j = 0;
				while (rref[rsub][j] != '\0')
					line[i++] = rref[rsub][j++];
				line[i++] = ' ';
			}

			++rsub;
		}
		
		strcat(line, "\n");
		olen = istrlen(line);
		of.write(line, olen);
	}

	strcpy(line, "\n\n");									// Total count.
	of.write(line, 2);
	strcpy(line, "Total");
	strncat(line,spaces,44);
	rjust_count(totalcount);
	strcat(line, "\n");
	olen = istrlen(line);
	of.write(line, olen);

	rf.close();

	return 0;

}

//---------------------------------------------------------------------
// This function reformats location ##-## to #### & #-# to 0#0#.
//---------------------------------------------------------------------

void rfmt(char *loc)
{

	char t1[4], t2[4];

	char *x, *y1, *y2;
	int l1, l2;

	x = loc;

	y1 = &t1[0];
	y2 = &t2[0];
	
	l1 = 0;
	l2 = 0;

	while((*x != '\0') && (*x != '-'))     // First number, # or ##
	{
		if ((*x >= '0') && (*x <= '9'))
		{
			*y1 = *x;
			++l1;
			++y1;
		}
		++x;
	}

	while(*x != '\0')                      // Second number, # or ##
	{
		if ((*x >= '0') && (*x <= '9'))
		{
			*y2 = *x;
			++l2;
			++y2;
		}
		++x;
	}

	x = loc;

	y1 = &t1[0];
	y2 = &t2[0];

	if (l1 == 1)       // First pair
		*x++ = '0';
	else
		*x++ = *y1++;

	*x++ = *y1++;

	if (l2 == 1)       // Second pair
		*x++ = '0';
	else
		*x++ = *y2++;

	*x++ = *y2++;

	*x = '\0';

}

//---------------------------------------------------------------------
// This function displays usage.
//---------------------------------------------------------------------

void display_usage(char *pgm)
{
		cout << "Usage: " << pgm
			 << " /h headerfile"
			 << " /l locfile"
			 << " /r reffile"
			 << " [/o outfile]" << endl
			 << "       " << pgm
			 << " /? (display this message)" << endl;
}

//---------------------------------------------------------------------
// This function converts char arrays to int.
//---------------------------------------------------------------------

int str2int(char *s)
{
	int result = 0;
	while (*s != '\0')
	{
		result *= 10;
		switch (*s++) 
		{
			case '1': result += 1; break;
			case '2': result += 2; break;
			case '3': result += 3; break;
			case '4': result += 4; break;
			case '5': result += 5; break;
			case '6': result += 6; break;
			case '7': result += 7; break;
			case '8': result += 8; break;
			case '9': result += 9; break;
		}
	}

	return result;
}

//---------------------------------------------------------------------
// This function returns int string length.
//---------------------------------------------------------------------

int istrlen(char *s)
{
	int length = 0;
	while (*s != '\0')
	{
		++length;
		++s; 
	}

	return length;
}

//---------------------------------------------------------------------
// This function inserts an integer value into char line[]
// right-justified at column line[48].
//---------------------------------------------------------------------

void rjust_count(int count)
{
	int result = count;
	int digit;
	int pos = 48;

	while (result > 0)
	{
		digit  = result % 10;
		result = result / 10;

		switch (digit)
		{
			case 0: line[pos] = '0'; break;
			case 1: line[pos] = '1'; break;
			case 2: line[pos] = '2'; break;
			case 3: line[pos] = '3'; break;
			case 4: line[pos] = '4'; break;
			case 5: line[pos] = '5'; break;
			case 6: line[pos] = '6'; break;
			case 7: line[pos] = '7'; break;
			case 8: line[pos] = '8'; break;
			case 9: line[pos] = '9'; break;
		}

		--pos;
	}
}

